'                                    Luefter 1A          06.08.2008

' Temperatur Sensor DS1820 an Pin D.6 als I2C
' Compiler Bascom
'------------------------------------------------------------------------------
'                          Konfiguration des Prozessors
$baud = 9600                  ' RS232 Datebetrasgungsrate
$regfile "m8def.dat"          'Definiert den Atmega als Atmega 8
$crystal = 3686400            'Gibt die Quarzfrequenz an in Herz
Config Lcd = 16 * 2           'definiert das LCD Display in Art und Gre
'-----------------------------------------------------------------------------
Ddrb = &B00000010             ' Portb.1 als Ausgang setzen
Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Down , Prescale = 1
Dim T As Byte
Dim T_soll As Byte
'--------------------------------------------------------------------------------
Ddrd = &B10000000             'Port D7  als Ausgang setzen alle anderen als eingang

Config 1wire = Portd.6        ' I2C an Port D.6 benutzen

Dim Ds1820 As Integer         'Integer Variabel fr Ds1820 setzen kann Daten minus 32768 bis+32768

Dim Halb As Byte              ' Varabel "Halb" als Byte setzen 0 bis 256

Print "Temperatur"

Print "mit ds1820"

Waitms 20
                        ' Pause von 1 Sekunden
'-------------------------------------------------------------------------------
' Lfter mit Voller Drehzahl erst einmal anlaufen lassen, damit dieses
' Frquenz Piepsen in den unteren Drehzahlen nicht strt
T = 255
Wait 5
'----------------------------------------------------------------------
' Hier wird die sollwert Temperatur festgelegt

T_soll = 30
'----------------------------------------------------------------------

      Do                      ' Schleifenanfang

Compare1a = T
' Ist die Temperatur ber 28 Grad dann erhhe Wert in T bei jedem
' Schleifendurchgang -Lfter wird schneller
' sonst veringer T bei jeden Durchgang

 If Ds1820 > T_soll Then      'Ist Variabel DS1820 grer 23 grad dann
   Incr T
   Else
   Decr T
  End If


 If T > 252 Then
 T = 253
 End If


  If T < 2 Then
  T = 1
   End If

 Print "Sollwer-Temperatur" ; T_soll

 Print "T " ; T

 Print "Temeratur" ; Ds1820

 Waitms 50

    '***********************************************************************'
 'Wait 1                       ' Pause von 1 Sekunde

1wreset                       ' Reset von DS1820 Temperaturfhler

1wwrite &HCC                  ' bersprimge Rom

1wwrite &H44                  ' Starte Temperaturkonvertierung

Waitms 300                    ' Pause von 300 millisekunden

1wreset                       ' Reset DS1820

1wwrite &HCC                  'berspringe Rom

1wwrite &HBE                  ' sende inhalt der register AAH und 00h

Ds1820 = 1wread(9)            'lese die empfangenen Daten

1wreset                       'Reset Ds1820

Halb = Ds1820 And 1           ' prfen auf letztes Byte

Locate 2 , 1                  ' Diplayausgabe 2.Zeile ,Spalte 1

Shift Ds1820 , Right          'entferne letztes bit

If Ds1820 > 127 Then          ' bei negativer Temperatur ein Minuszeichen auf Display ausgeben

 Lcd "-"
  Cls                         ' Display lschen

Ds1820 = 256 - Ds1820         ' Minus Temperatur berechnen

If Halb = 1 Then Ds1820 = Ds1820 -1       'wenn Wert X,5 dann um 1 korrigieren

Else                          ' sonst keine Ausgabe auf Display

Lcd ""

   If Ds1820 > T_soll Then    'Ist Variabel DS1820 grer 23 grad dann
   Portd.7 = 1                ' Port D.7 einschalten
   Else                       ' sonst
   Portd.7 = 0                ' Port D.7 auslassen
   End If                     ' Ausgabe Temperatur und Komma


Lcd Ds1820 ; ".";             'wenn X,5
Print Ds1820


If Halb = 1 Then              'dann eine 5 nach Komma ausgeben

 Lcd "5"
Else
Lcd "0"                       ' sonst Null nach Komma ausgeben

End If
Lcd "C"
Print "C"
'Wait 2


  End If

      Loop                    ' zum Anfang der Schleife

End